#include <Application.h>
#include "TWindow.h"
#include "TView.h"

TWindow::TWindow(BRect frame)
				: BWindow(frame, "X-Copy 1.0b", B_TITLED_WINDOW, Flags() | B_NOT_RESIZABLE | B_NOT_ZOOMABLE)
{
//  	SetPulseRate(250*1000); //4 fois par second 

  	SetPulseRate(THE_RATE);
  	
	theView = new TView(Bounds(), "");
	AddChild(theView);
	
	load_panel_created = false;
	save_panel_created = false;

PostMessage(MODE_1440);

}

bool TWindow::QuitRequested()
{
	be_app->PostMessage(B_QUIT_REQUESTED);
	return(true);
} 

void
TWindow::MessageReceived(BMessage* message)
{
int32 i;
int32 val;
float virgule;
BAlert *wanna_write;
int32 button_index;

	switch(message->what)
	{
	
	//	case WARNING_CHANGED:
	
		case DO_ENABLE_ALL:
		theView->EnableAll();
		break;
		
		case DO_ENABLE_READ:
		theView->read->SetEnabled(true);
		theView->load->SetEnabled(true);
		theView->boot->SetEnabled(true);
		break;

		case WRITE_IT:
		
		if (theView->warnings->Value()==B_CONTROL_OFF) 
			{
		
			wanna_write = new BAlert("","This will DESTROY the current contents of the disk in drive, be sure to have the DESTINATION DISK inside.",
                     "Cancel","Go on",NULL, B_WIDTH_FROM_WIDEST, B_INFO_ALERT); 
			  
			switch(button_index = wanna_write->Go())  {case 0:	return;	break; }
 	 		
 	 		}
		//otherwise we can go on and write
				
		is_reading = false;
		init_params();
		theView->DisableAll(); //disable buttons
		theView->status->SetText("Writing sectors to floppy...");
		PostMessage(CLEAR_DEST);
		
		sprintf(str,"XCopy"); //nom de l'application ;-)
		
		sprintf(stra,"if="DEFAULT_TEMP_FILE);
		sprintf(strb,"of=/dev/disk/floppy/raw");
		sprintf(strc,"bs=20480"); 
		
		ptr[0]=NULL; ptr[1]=NULL; ptr[2]=NULL; ptr[3]=NULL;  
		ptr[4]=NULL; ptr[5]=NULL; ptr[6]=NULL; ptr[7]=NULL;  
		
		//These two are essential 
		ptr[0]=str;  ptr[1]=stra;  ptr[2]=strb;  ptr[3]=strc;  
		nb_args=4;

		be_app->ArgvReceived(nb_args,ptr);
		
		break;
		
		case BOOT_IT:
		
		if (theView->warnings->Value()==B_CONTROL_OFF) 
			{
		
			wanna_write = new BAlert("","Insert a blank disk to create a BeOS boot floppy. This will of course destroy all previous data on the disk.",
                     "Cancel","Go on",NULL, B_WIDTH_FROM_WIDEST, B_INFO_ALERT); 
			  
			switch(button_index = wanna_write->Go())  {case 0:	return;	break; }
 	 		
 	 		}
		//otherwise we can go on and write
		
		
		is_reading = false;
		init_params();
		theView->DisableAll(); //disable buttons
		theView->status->SetText("Creating boot floppy...");
		PostMessage(CLEAR_DEST);
		
		sprintf(str,"XCopy"); //nom de l'application ;-)
		
		sprintf(strb,"if=/boot/beos/system/zbeos");
		sprintf(stra,"of=/dev/disk/floppy/raw");
		sprintf(strc,"bs=20480"); 

		ptr[0]=NULL; ptr[1]=NULL; ptr[2]=NULL; ptr[3]=NULL;  
		ptr[4]=NULL; ptr[5]=NULL; ptr[6]=NULL; ptr[7]=NULL;  
		
		//These two are essential 
		ptr[0]=str;  ptr[1]=stra;  ptr[2]=strb;   ptr[3]=strc;  
		nb_args=4;

		be_app->ArgvReceived(nb_args,ptr);
		
		break;
		
		
		case READ_IT:
		is_reading = true;
		init_params();
		theView->DisableAll(); //disable buttons
		theView->status->SetText("Reading sectors from floppy...");
		PostMessage(CLEAR_SOURCE);
		PostMessage(CLEAR_DEST);

		sprintf(str,"XCopy"); //nom de l'application ;-)
		
		sprintf(stra,"if=/dev/disk/floppy/raw");
		sprintf(strb,"of="DEFAULT_TEMP_FILE);
		sprintf(strc,"bs=20480"); 

		ptr[0]=NULL; ptr[1]=NULL; ptr[2]=NULL; ptr[3]=NULL;  
		ptr[4]=NULL; ptr[5]=NULL; ptr[6]=NULL; ptr[7]=NULL;  
		
		//These two are essential 
		ptr[0]=str;  ptr[1]=stra;  ptr[2]=strb;  ptr[3]=strc;  
		nb_args=4;


		be_app->ArgvReceived(nb_args,ptr);
		
		break;
		 
		
		case LOAD_IT:
		if (load_panel_created == false)
			{
				load_panel = new BFilePanel();
				load_panel_created = true;
			}
		load_panel->Show();
		break;
		
		
		case SAVE_IT:
		if (save_panel_created == false)
			{
				save_panel = new BFilePanel(B_SAVE_PANEL);
				save_panel->SetTarget(this);
				CreateSavePanel();
				save_panel_created = true;
			}
		save_panel->Show();

		break;
		
		
		//--------------------------------
		

		case B_SAVE_REQUESTED:
		be_app->PostMessage(message); //faut que ce soit l'app qui le traite sinon ça bloque la win...
		break;

		case ABOUT_BOX:
  		alert = new BAlert("", 
                     "X-Copy 1.0b for the BeOS\n\n"
                     "by Santiago Lema <santiago.lema@cryogen.ch>\n"
                     "based on GNU's fileutils 3.12\n" 
                     "Freeware: see included license\n\n"
                     "Get latest version on Beware or at:\n"
                     "http://www.beoscentral.com/home/free/\n"
                     "\nReleased in May 1999.", 
                     "Grmbl?",NULL,NULL, B_WIDTH_FROM_WIDEST, B_INFO_ALERT); 
   		 alert->Go(NULL);
 	  break;
		
	case FILL_SOURCE:
	
  	i = 1;
  	
  	    virgule =  float(theView->total_read/512) /2880;
  	//  printf("\nTotal:      %ld",theView->total_read);
  	//  printf("\nPercentage: %f",virgule);
  	    val = (int32) (72 *virgule);
  	    
	theView->blocks_src->ClearIt();
  	
  		while (i!=val+1)
		{		
			theView->blocks_src->SetPal(int8(i-1),0,200-i,0);	 //the previous back_to normal
			
			i++;
		}		
			theView->blocks_src->UpdatePic(); 	
			theView->blocks_src->Draw(theView->blocks_src->Bounds());
			
	break;
		
	case CLEAR_SOURCE:
	theView->blocks_src->ClearIt();
	break;
	
	case CLEAR_DEST:
	theView->blocks_dest->ClearIt();
	break;
	
		//---------------------------------
	
	case MODE_1440:
	break;
	
	case MODE_720:
	break;
	
		
		default:
			BWindow::MessageReceived(message);
	}
}

void TWindow::FrameResized(float x,float y)
{

be_app->Lock();
Lock();
BBox *a = theView->src;
BBox *b = theView->dest;

float delta = (a->Bounds().Width() - b->Bounds().Width()) /2;

float largeur = a->Bounds().Width()-delta;

a->ResizeTo(largeur,largeur);
b->MoveBy(delta*-1, 0);
b->ResizeTo(largeur,largeur);

Lock();
be_app->Unlock();

}

void TWindow::CreateSavePanel()
{


BWindow *win = save_panel->Window();


be_app->Lock();
win->Lock();
BView *background = save_panel->Window()->ChildAt(0);

save_panel->SetSaveText("disk00.img");
BRect rect = background->Bounds();
rect.right = 200;
rect.top = rect.bottom-16;
rect.OffsetBy(11,-2);

zip_or_not = new BCheckBox(rect,"","Compress image (requires gzip)",NULL, B_FOLLOW_LEFT | B_FOLLOW_BOTTOM, B_WILL_DRAW);
zip_or_not->SetValue(B_CONTROL_ON);

background->AddChild(zip_or_not);

win->Unlock();
be_app->Unlock();


}
